Merge branch 'zh/ref-filter-atom-type'
[git] / t / test-lib.sh
1 # Test framework for git.  See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # Test the binaries we have just built.  The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22         # We allow tests to override this, in case they want to run tests
23         # outside of t/, e.g. for running tests on the test library
24         # itself.
25         TEST_DIRECTORY=$(pwd)
26 else
27         # ensure that TEST_DIRECTORY is an absolute path so that it
28         # is valid even if the current working directory is changed
29         TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
30 fi
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33         # Similarly, override this to store the test-results subdir
34         # elsewhere
35         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 fi
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
46
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
50 export LSAN_OPTIONS
51
52 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
53 then
54         echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
55         exit 1
56 fi
57 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58 export PERL_PATH SHELL_PATH
59
60 # Disallow the use of abbreviated options in the test suite by default
61 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
62 then
63         GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
64         export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
65 fi
66
67 ################################################################
68 # It appears that people try to run tests without building...
69 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
70 if test $? != 1
71 then
72         if test -n "$GIT_TEST_INSTALLED"
73         then
74                 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
75         else
76                 echo >&2 'error: you do not seem to have built git yet.'
77         fi
78         exit 1
79 fi
80
81 store_arg_to=
82 opt_required_arg=
83 # $1: option string
84 # $2: name of the var where the arg will be stored
85 mark_option_requires_arg () {
86         if test -n "$opt_required_arg"
87         then
88                 echo "error: options that require args cannot be bundled" \
89                         "together: '$opt_required_arg' and '$1'" >&2
90                 exit 1
91         fi
92         opt_required_arg=$1
93         store_arg_to=$2
94 }
95
96 parse_option () {
97         local opt="$1"
98
99         case "$opt" in
100         -d|--d|--de|--deb|--debu|--debug)
101                 debug=t ;;
102         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
103                 immediate=t ;;
104         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
105                 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
106         -r)
107                 mark_option_requires_arg "$opt" run_list
108                 ;;
109         --run=*)
110                 run_list=${opt#--*=} ;;
111         -h|--h|--he|--hel|--help)
112                 help=t ;;
113         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
114                 verbose=t ;;
115         --verbose-only=*)
116                 verbose_only=${opt#--*=}
117                 ;;
118         -q|--q|--qu|--qui|--quie|--quiet)
119                 # Ignore --quiet under a TAP::Harness. Saying how many tests
120                 # passed without the ok/not ok details is always an error.
121                 test -z "$HARNESS_ACTIVE" && quiet=t ;;
122         --with-dashes)
123                 with_dashes=t ;;
124         --no-bin-wrappers)
125                 no_bin_wrappers=t ;;
126         --no-color)
127                 color= ;;
128         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
129                 valgrind=memcheck
130                 tee=t
131                 ;;
132         --valgrind=*)
133                 valgrind=${opt#--*=}
134                 tee=t
135                 ;;
136         --valgrind-only=*)
137                 valgrind_only=${opt#--*=}
138                 tee=t
139                 ;;
140         --tee)
141                 tee=t ;;
142         --root=*)
143                 root=${opt#--*=} ;;
144         --chain-lint)
145                 GIT_TEST_CHAIN_LINT=1 ;;
146         --no-chain-lint)
147                 GIT_TEST_CHAIN_LINT=0 ;;
148         -x)
149                 trace=t ;;
150         -V|--verbose-log)
151                 verbose_log=t
152                 tee=t
153                 ;;
154         --write-junit-xml)
155                 write_junit_xml=t
156                 ;;
157         --stress)
158                 stress=t ;;
159         --stress=*)
160                 echo "error: --stress does not accept an argument: '$opt'" >&2
161                 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
162                 exit 1
163                 ;;
164         --stress-jobs=*)
165                 stress=t;
166                 stress_jobs=${opt#--*=}
167                 case "$stress_jobs" in
168                 *[!0-9]*|0*|"")
169                         echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
170                         exit 1
171                         ;;
172                 *)      # Good.
173                         ;;
174                 esac
175                 ;;
176         --stress-limit=*)
177                 stress=t;
178                 stress_limit=${opt#--*=}
179                 case "$stress_limit" in
180                 *[!0-9]*|0*|"")
181                         echo "error: --stress-limit=<N> requires the number of repetitions" >&2
182                         exit 1
183                         ;;
184                 *)      # Good.
185                         ;;
186                 esac
187                 ;;
188         *)
189                 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
190         esac
191 }
192
193 # Parse options while taking care to leave $@ intact, so we will still
194 # have all the original command line options when executing the test
195 # script again for '--tee' and '--verbose-log' later.
196 for opt
197 do
198         if test -n "$store_arg_to"
199         then
200                 eval $store_arg_to=\$opt
201                 store_arg_to=
202                 opt_required_arg=
203                 continue
204         fi
205
206         case "$opt" in
207         --*|-?)
208                 parse_option "$opt" ;;
209         -?*)
210                 # bundled short options must be fed separately to parse_option
211                 opt=${opt#-}
212                 while test -n "$opt"
213                 do
214                         extra=${opt#?}
215                         this=${opt%$extra}
216                         opt=$extra
217                         parse_option "-$this"
218                 done
219                 ;;
220         *)
221                 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
222         esac
223 done
224 if test -n "$store_arg_to"
225 then
226         echo "error: $opt_required_arg requires an argument" >&2
227         exit 1
228 fi
229
230 if test -n "$valgrind_only"
231 then
232         test -z "$valgrind" && valgrind=memcheck
233         test -z "$verbose" && verbose_only="$valgrind_only"
234 elif test -n "$valgrind"
235 then
236         test -z "$verbose_log" && verbose=t
237 fi
238
239 if test -n "$stress"
240 then
241         verbose=t
242         trace=t
243         immediate=t
244 fi
245
246 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
247 TEST_NAME="$(basename "$0" .sh)"
248 TEST_NUMBER="${TEST_NAME%%-*}"
249 TEST_NUMBER="${TEST_NUMBER#t}"
250 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
251 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
252 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
253 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
254 case "$TRASH_DIRECTORY" in
255 /*) ;; # absolute path is good
256  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
257 esac
258
259 # If --stress was passed, run this test repeatedly in several parallel loops.
260 if test "$GIT_TEST_STRESS_STARTED" = "done"
261 then
262         : # Don't stress test again.
263 elif test -n "$stress"
264 then
265         if test -n "$stress_jobs"
266         then
267                 job_count=$stress_jobs
268         elif test -n "$GIT_TEST_STRESS_LOAD"
269         then
270                 job_count="$GIT_TEST_STRESS_LOAD"
271         elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
272              test -n "$job_count"
273         then
274                 job_count=$((2 * $job_count))
275         else
276                 job_count=8
277         fi
278
279         mkdir -p "$TEST_RESULTS_DIR"
280         stressfail="$TEST_RESULTS_BASE.stress-failed"
281         rm -f "$stressfail"
282
283         stress_exit=0
284         trap '
285                 kill $job_pids 2>/dev/null
286                 wait
287                 stress_exit=1
288         ' TERM INT HUP
289
290         job_pids=
291         job_nr=0
292         while test $job_nr -lt "$job_count"
293         do
294                 (
295                         GIT_TEST_STRESS_STARTED=done
296                         GIT_TEST_STRESS_JOB_NR=$job_nr
297                         export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
298
299                         trap '
300                                 kill $test_pid 2>/dev/null
301                                 wait
302                                 exit 1
303                         ' TERM INT
304
305                         cnt=1
306                         while ! test -e "$stressfail" &&
307                               { test -z "$stress_limit" ||
308                                 test $cnt -le $stress_limit ; }
309                         do
310                                 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
311                                 test_pid=$!
312
313                                 if wait $test_pid
314                                 then
315                                         printf "OK   %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
316                                 else
317                                         echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
318                                         printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
319                                 fi
320                                 cnt=$(($cnt + 1))
321                         done
322                 ) &
323                 job_pids="$job_pids $!"
324                 job_nr=$(($job_nr + 1))
325         done
326
327         wait
328
329         if test -f "$stressfail"
330         then
331                 stress_exit=1
332                 echo "Log(s) of failed test run(s):"
333                 for failed_job_nr in $(sort -n "$stressfail")
334                 do
335                         echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
336                         cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
337                 done
338                 rm -rf "$TRASH_DIRECTORY.stress-failed"
339                 # Move the last one.
340                 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
341         fi
342
343         exit $stress_exit
344 fi
345
346 # if --tee was passed, write the output not only to the terminal, but
347 # additionally to the file test-results/$BASENAME.out, too.
348 if test "$GIT_TEST_TEE_STARTED" = "done"
349 then
350         : # do not redirect again
351 elif test -n "$tee"
352 then
353         mkdir -p "$TEST_RESULTS_DIR"
354
355         # Make this filename available to the sub-process in case it is using
356         # --verbose-log.
357         GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
358         export GIT_TEST_TEE_OUTPUT_FILE
359
360         # Truncate before calling "tee -a" to get rid of the results
361         # from any previous runs.
362         >"$GIT_TEST_TEE_OUTPUT_FILE"
363
364         (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
365          echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
366         test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
367         exit
368 fi
369
370 if test -n "$trace" && test -n "$test_untraceable"
371 then
372         # '-x' tracing requested, but this test script can't be reliably
373         # traced, unless it is run with a Bash version supporting
374         # BASH_XTRACEFD (introduced in Bash v4.1).
375         #
376         # Perform this version check _after_ the test script was
377         # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
378         # '--verbose-log', so the right shell is checked and the
379         # warning is issued only once.
380         if test -n "$BASH_VERSION" && eval '
381              test ${BASH_VERSINFO[0]} -gt 4 || {
382                test ${BASH_VERSINFO[0]} -eq 4 &&
383                test ${BASH_VERSINFO[1]} -ge 1
384              }
385            '
386         then
387                 : Executed by a Bash version supporting BASH_XTRACEFD.  Good.
388         else
389                 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
390                 trace=
391         fi
392 fi
393 if test -n "$trace" && test -z "$verbose_log"
394 then
395         verbose=t
396 fi
397
398 # For repeatability, reset the environment to known value.
399 # TERM is sanitized below, after saving color control sequences.
400 LANG=C
401 LC_ALL=C
402 PAGER=cat
403 TZ=UTC
404 export LANG LC_ALL PAGER TZ
405 EDITOR=:
406
407 # A call to "unset" with no arguments causes at least Solaris 10
408 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
409 # deriving from the command substitution clustered with the other
410 # ones.
411 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
412         my @env = keys %ENV;
413         my $ok = join("|", qw(
414                 TRACE
415                 DEBUG
416                 TEST
417                 .*_TEST
418                 PROVE
419                 VALGRIND
420                 UNZIP
421                 PERF_
422                 CURL_VERBOSE
423                 TRACE_CURL
424         ));
425         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
426         print join("\n", @vars);
427 ')
428 unset XDG_CACHE_HOME
429 unset XDG_CONFIG_HOME
430 unset GITPERLLIB
431 TEST_AUTHOR_LOCALNAME=author
432 TEST_AUTHOR_DOMAIN=example.com
433 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
434 GIT_AUTHOR_NAME='A U Thor'
435 GIT_AUTHOR_DATE='1112354055 +0200'
436 TEST_COMMITTER_LOCALNAME=committer
437 TEST_COMMITTER_DOMAIN=example.com
438 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
439 GIT_COMMITTER_NAME='C O Mitter'
440 GIT_COMMITTER_DATE='1112354055 +0200'
441 GIT_MERGE_VERBOSITY=5
442 GIT_MERGE_AUTOEDIT=no
443 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
444 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
445 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
446 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
447 export EDITOR
448
449 GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
450 export GIT_DEFAULT_HASH
451 GIT_TEST_MERGE_ALGORITHM="${GIT_TEST_MERGE_ALGORITHM:-ort}"
452 export GIT_TEST_MERGE_ALGORITHM
453
454 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
455 GIT_TRACE_BARE=1
456 export GIT_TRACE_BARE
457
458 # Use specific version of the index file format
459 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
460 then
461         GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
462         export GIT_INDEX_VERSION
463 fi
464
465 if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
466 then
467         GIT_PERL_FATAL_WARNINGS=1
468         export GIT_PERL_FATAL_WARNINGS
469 fi
470
471 # Add libc MALLOC and MALLOC_PERTURB test
472 # only if we are not executing the test with valgrind
473 if test -n "$valgrind" ||
474    test -n "$TEST_NO_MALLOC_CHECK"
475 then
476         setup_malloc_check () {
477                 : nothing
478         }
479         teardown_malloc_check () {
480                 : nothing
481         }
482 else
483         setup_malloc_check () {
484                 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
485                 export MALLOC_CHECK_ MALLOC_PERTURB_
486         }
487         teardown_malloc_check () {
488                 unset MALLOC_CHECK_ MALLOC_PERTURB_
489         }
490 fi
491
492 # Protect ourselves from common misconfiguration to export
493 # CDPATH into the environment
494 unset CDPATH
495
496 unset GREP_OPTIONS
497 unset UNZIP
498
499 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
500 1|2|true)
501         GIT_TRACE=4
502         ;;
503 esac
504
505 # Line feed
506 LF='
507 '
508
509 # Single quote
510 SQ=\'
511
512 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
513 # when case-folding filenames
514 u200c=$(printf '\342\200\214')
515
516 export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
517
518 # Each test should start with something like this, after copyright notices:
519 #
520 # test_description='Description of this test...
521 # This test checks if command xyzzy does the right thing...
522 # '
523 # . ./test-lib.sh
524 test "x$TERM" != "xdumb" && (
525                 test -t 1 &&
526                 tput bold >/dev/null 2>&1 &&
527                 tput setaf 1 >/dev/null 2>&1 &&
528                 tput sgr0 >/dev/null 2>&1
529         ) &&
530         color=t
531
532 if test -n "$color"
533 then
534         # Save the color control sequences now rather than run tput
535         # each time say_color() is called.  This is done for two
536         # reasons:
537         #   * TERM will be changed to dumb
538         #   * HOME will be changed to a temporary directory and tput
539         #     might need to read ~/.terminfo from the original HOME
540         #     directory to get the control sequences
541         # Note:  This approach assumes the control sequences don't end
542         # in a newline for any terminal of interest (command
543         # substitutions strip trailing newlines).  Given that most
544         # (all?) terminals in common use are related to ECMA-48, this
545         # shouldn't be a problem.
546         say_color_error=$(tput bold; tput setaf 1) # bold red
547         say_color_skip=$(tput setaf 4) # blue
548         say_color_warn=$(tput setaf 3) # brown/yellow
549         say_color_pass=$(tput setaf 2) # green
550         say_color_info=$(tput setaf 6) # cyan
551         say_color_reset=$(tput sgr0)
552         say_color_="" # no formatting for normal text
553         say_color () {
554                 test -z "$1" && test -n "$quiet" && return
555                 eval "say_color_color=\$say_color_$1"
556                 shift
557                 printf "%s\\n" "$say_color_color$*$say_color_reset"
558         }
559 else
560         say_color() {
561                 test -z "$1" && test -n "$quiet" && return
562                 shift
563                 printf "%s\n" "$*"
564         }
565 fi
566
567 TERM=dumb
568 export TERM
569
570 error () {
571         say_color error "error: $*"
572         finalize_junit_xml
573         GIT_EXIT_OK=t
574         exit 1
575 }
576
577 BUG () {
578         error >&7 "bug in the test script: $*"
579 }
580
581 say () {
582         say_color info "$*"
583 }
584
585 if test -n "$HARNESS_ACTIVE"
586 then
587         if test "$verbose" = t || test -n "$verbose_only"
588         then
589                 printf 'Bail out! %s\n' \
590                  'verbose mode forbidden under TAP harness; try --verbose-log'
591                 exit 1
592         fi
593 fi
594
595 test "${test_description}" != "" ||
596 error "Test script did not set test_description."
597
598 if test "$help" = "t"
599 then
600         printf '%s\n' "$test_description"
601         exit 0
602 fi
603
604 exec 5>&1
605 exec 6<&0
606 exec 7>&2
607 if test "$verbose_log" = "t"
608 then
609         exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
610 elif test "$verbose" = "t"
611 then
612         exec 4>&2 3>&1
613 else
614         exec 4>/dev/null 3>/dev/null
615 fi
616
617 # Send any "-x" output directly to stderr to avoid polluting tests
618 # which capture stderr. We can do this unconditionally since it
619 # has no effect if tracing isn't turned on.
620 #
621 # Note that this sets up the trace fd as soon as we assign the variable, so it
622 # must come after the creation of descriptor 4 above. Likewise, we must never
623 # unset this, as it has the side effect of closing descriptor 4, which we
624 # use to show verbose tests to the user.
625 #
626 # Note also that we don't need or want to export it. The tracing is local to
627 # this shell, and we would not want to influence any shells we exec.
628 BASH_XTRACEFD=4
629
630 test_failure=0
631 test_count=0
632 test_fixed=0
633 test_broken=0
634 test_success=0
635
636 test_external_has_tap=0
637
638 die () {
639         code=$?
640         # This is responsible for running the atexit commands even when a
641         # test script run with '--immediate' fails, or when the user hits
642         # ctrl-C, i.e. when 'test_done' is not invoked at all.
643         test_atexit_handler || code=$?
644         if test -n "$GIT_EXIT_OK"
645         then
646                 exit $code
647         else
648                 echo >&5 "FATAL: Unexpected exit with code $code"
649                 exit 1
650         fi
651 }
652
653 GIT_EXIT_OK=
654 trap 'die' EXIT
655 # Disable '-x' tracing, because with some shells, notably dash, it
656 # prevents running the cleanup commands when a test script run with
657 # '--verbose-log -x' is interrupted.
658 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
659
660 # The user-facing functions are loaded from a separate file so that
661 # test_perf subshells can have them too
662 . "$TEST_DIRECTORY/test-lib-functions.sh"
663
664 # You are not expected to call test_ok_ and test_failure_ directly, use
665 # the test_expect_* functions instead.
666
667 test_ok_ () {
668         if test -n "$write_junit_xml"
669         then
670                 write_junit_xml_testcase "$*"
671         fi
672         test_success=$(($test_success + 1))
673         say_color "" "ok $test_count - $@"
674 }
675
676 test_failure_ () {
677         if test -n "$write_junit_xml"
678         then
679                 junit_insert="<failure message=\"not ok $test_count -"
680                 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
681                 junit_insert="$junit_insert $(xml_attr_encode \
682                         "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
683                            then
684                                 test-tool path-utils skip-n-bytes \
685                                         "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
686                            else
687                                 printf '%s\n' "$@" | sed 1d
688                            fi)")"
689                 junit_insert="$junit_insert</failure>"
690                 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
691                 then
692                         junit_insert="$junit_insert<system-err>$(xml_attr_encode \
693                                 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
694                 fi
695                 write_junit_xml_testcase "$1" "      $junit_insert"
696         fi
697         test_failure=$(($test_failure + 1))
698         say_color error "not ok $test_count - $1"
699         shift
700         printf '%s\n' "$*" | sed -e 's/^/#      /'
701         test "$immediate" = "" || { finalize_junit_xml; GIT_EXIT_OK=t; exit 1; }
702 }
703
704 test_known_broken_ok_ () {
705         if test -n "$write_junit_xml"
706         then
707                 write_junit_xml_testcase "$* (breakage fixed)"
708         fi
709         test_fixed=$(($test_fixed+1))
710         say_color error "ok $test_count - $@ # TODO known breakage vanished"
711 }
712
713 test_known_broken_failure_ () {
714         if test -n "$write_junit_xml"
715         then
716                 write_junit_xml_testcase "$* (known breakage)"
717         fi
718         test_broken=$(($test_broken+1))
719         say_color warn "not ok $test_count - $@ # TODO known breakage"
720 }
721
722 test_debug () {
723         test "$debug" = "" || eval "$1"
724 }
725
726 match_pattern_list () {
727         arg="$1"
728         shift
729         test -z "$*" && return 1
730         for pattern_
731         do
732                 case "$arg" in
733                 $pattern_)
734                         return 0
735                 esac
736         done
737         return 1
738 }
739
740 match_test_selector_list () {
741         operation="$1"
742         shift
743         title="$1"
744         shift
745         arg="$1"
746         shift
747         test -z "$1" && return 0
748
749         # Commas are accepted as separators.
750         OLDIFS=$IFS
751         IFS=','
752         set -- $1
753         IFS=$OLDIFS
754
755         # If the first selector is negative we include by default.
756         include=
757         case "$1" in
758                 !*) include=t ;;
759         esac
760
761         for selector
762         do
763                 orig_selector=$selector
764
765                 positive=t
766                 case "$selector" in
767                         !*)
768                                 positive=
769                                 selector=${selector##?}
770                                 ;;
771                 esac
772
773                 test -z "$selector" && continue
774
775                 case "$selector" in
776                         *-*)
777                                 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
778                                 then
779                                         echo "error: $operation: invalid non-numeric in range" \
780                                                 "start: '$orig_selector'" >&2
781                                         exit 1
782                                 fi
783                                 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
784                                 then
785                                         echo "error: $operation: invalid non-numeric in range" \
786                                                 "end: '$orig_selector'" >&2
787                                         exit 1
788                                 fi
789                                 ;;
790                         *)
791                                 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
792                                 then
793                                         case "$title" in *${selector}*)
794                                                 include=$positive
795                                                 ;;
796                                         esac
797                                         continue
798                                 fi
799                 esac
800
801                 # Short cut for "obvious" cases
802                 test -z "$include" && test -z "$positive" && continue
803                 test -n "$include" && test -n "$positive" && continue
804
805                 case "$selector" in
806                         -*)
807                                 if test $arg -le ${selector#-}
808                                 then
809                                         include=$positive
810                                 fi
811                                 ;;
812                         *-)
813                                 if test $arg -ge ${selector%-}
814                                 then
815                                         include=$positive
816                                 fi
817                                 ;;
818                         *-*)
819                                 if test ${selector%%-*} -le $arg \
820                                         && test $arg -le ${selector#*-}
821                                 then
822                                         include=$positive
823                                 fi
824                                 ;;
825                         *)
826                                 if test $arg -eq $selector
827                                 then
828                                         include=$positive
829                                 fi
830                                 ;;
831                 esac
832         done
833
834         test -n "$include"
835 }
836
837 maybe_teardown_verbose () {
838         test -z "$verbose_only" && return
839         exec 4>/dev/null 3>/dev/null
840         verbose=
841 }
842
843 last_verbose=t
844 maybe_setup_verbose () {
845         test -z "$verbose_only" && return
846         if match_pattern_list $test_count $verbose_only
847         then
848                 exec 4>&2 3>&1
849                 # Emit a delimiting blank line when going from
850                 # non-verbose to verbose.  Within verbose mode the
851                 # delimiter is printed by test_expect_*.  The choice
852                 # of the initial $last_verbose is such that before
853                 # test 1, we do not print it.
854                 test -z "$last_verbose" && echo >&3 ""
855                 verbose=t
856         else
857                 exec 4>/dev/null 3>/dev/null
858                 verbose=
859         fi
860         last_verbose=$verbose
861 }
862
863 maybe_teardown_valgrind () {
864         test -z "$GIT_VALGRIND" && return
865         GIT_VALGRIND_ENABLED=
866 }
867
868 maybe_setup_valgrind () {
869         test -z "$GIT_VALGRIND" && return
870         if test -z "$valgrind_only"
871         then
872                 GIT_VALGRIND_ENABLED=t
873                 return
874         fi
875         GIT_VALGRIND_ENABLED=
876         if match_pattern_list $test_count $valgrind_only
877         then
878                 GIT_VALGRIND_ENABLED=t
879         fi
880 }
881
882 trace_level_=0
883 want_trace () {
884         test "$trace" = t && {
885                 test "$verbose" = t || test "$verbose_log" = t
886         }
887 }
888
889 # This is a separate function because some tests use
890 # "return" to end a test_expect_success block early
891 # (and we want to make sure we run any cleanup like
892 # "set +x").
893 test_eval_inner_ () {
894         # Do not add anything extra (including LF) after '$*'
895         eval "
896                 want_trace && trace_level_=$(($trace_level_+1)) && set -x
897                 $*"
898 }
899
900 test_eval_ () {
901         # If "-x" tracing is in effect, then we want to avoid polluting stderr
902         # with non-test commands. But once in "set -x" mode, we cannot prevent
903         # the shell from printing the "set +x" to turn it off (nor the saving
904         # of $? before that). But we can make sure that the output goes to
905         # /dev/null.
906         #
907         # There are a few subtleties here:
908         #
909         #   - we have to redirect descriptor 4 in addition to 2, to cover
910         #     BASH_XTRACEFD
911         #
912         #   - the actual eval has to come before the redirection block (since
913         #     it needs to see descriptor 4 to set up its stderr)
914         #
915         #   - likewise, any error message we print must be outside the block to
916         #     access descriptor 4
917         #
918         #   - checking $? has to come immediately after the eval, but it must
919         #     be _inside_ the block to avoid polluting the "set -x" output
920         #
921
922         test_eval_inner_ "$@" </dev/null >&3 2>&4
923         {
924                 test_eval_ret_=$?
925                 if want_trace
926                 then
927                         test 1 = $trace_level_ && set +x
928                         trace_level_=$(($trace_level_-1))
929                 fi
930         } 2>/dev/null 4>&2
931
932         if test "$test_eval_ret_" != 0 && want_trace
933         then
934                 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
935         fi
936         return $test_eval_ret_
937 }
938
939 test_run_ () {
940         test_cleanup=:
941         expecting_failure=$2
942
943         if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
944                 # turn off tracing for this test-eval, as it simply creates
945                 # confusing noise in the "-x" output
946                 trace_tmp=$trace
947                 trace=
948                 # 117 is magic because it is unlikely to match the exit
949                 # code of other programs
950                 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)" ||
951                    {
952                         test "${GIT_TEST_CHAIN_LINT_HARDER:-${GIT_TEST_CHAIN_LINT_HARDER_DEFAULT:-1}}" != 0 &&
953                         $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!')
954                    }
955                 then
956                         BUG "broken &&-chain or run-away HERE-DOC: $1"
957                 fi
958                 trace=$trace_tmp
959         fi
960
961         setup_malloc_check
962         test_eval_ "$1"
963         eval_ret=$?
964         teardown_malloc_check
965
966         if test -z "$immediate" || test $eval_ret = 0 ||
967            test -n "$expecting_failure" && test "$test_cleanup" != ":"
968         then
969                 setup_malloc_check
970                 test_eval_ "$test_cleanup"
971                 teardown_malloc_check
972         fi
973         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
974         then
975                 echo ""
976         fi
977         return "$eval_ret"
978 }
979
980 test_start_ () {
981         test_count=$(($test_count+1))
982         maybe_setup_verbose
983         maybe_setup_valgrind
984         if test -n "$write_junit_xml"
985         then
986                 junit_start=$(test-tool date getnanos)
987         fi
988 }
989
990 test_finish_ () {
991         echo >&3 ""
992         maybe_teardown_valgrind
993         maybe_teardown_verbose
994         if test -n "$GIT_TEST_TEE_OFFSET"
995         then
996                 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
997                         "$GIT_TEST_TEE_OUTPUT_FILE")
998         fi
999 }
1000
1001 test_skip () {
1002         to_skip=
1003         skipped_reason=
1004         if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
1005         then
1006                 to_skip=t
1007                 skipped_reason="GIT_SKIP_TESTS"
1008         fi
1009         if test -z "$to_skip" && test -n "$run_list" &&
1010            ! match_test_selector_list '--run' "$1" $test_count "$run_list"
1011         then
1012                 to_skip=t
1013                 skipped_reason="--run"
1014         fi
1015         if test -z "$to_skip" && test -n "$test_prereq" &&
1016            ! test_have_prereq "$test_prereq"
1017         then
1018                 to_skip=t
1019
1020                 of_prereq=
1021                 if test "$missing_prereq" != "$test_prereq"
1022                 then
1023                         of_prereq=" of $test_prereq"
1024                 fi
1025                 skipped_reason="missing $missing_prereq${of_prereq}"
1026         fi
1027
1028         case "$to_skip" in
1029         t)
1030                 if test -n "$write_junit_xml"
1031                 then
1032                         message="$(xml_attr_encode "$skipped_reason")"
1033                         write_junit_xml_testcase "$1" \
1034                                 "      <skipped message=\"$message\" />"
1035                 fi
1036
1037                 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1038                 : true
1039                 ;;
1040         *)
1041                 false
1042                 ;;
1043         esac
1044 }
1045
1046 # stub; perf-lib overrides it
1047 test_at_end_hook_ () {
1048         :
1049 }
1050
1051 write_junit_xml () {
1052         case "$1" in
1053         --truncate)
1054                 >"$junit_xml_path"
1055                 junit_have_testcase=
1056                 shift
1057                 ;;
1058         esac
1059         printf '%s\n' "$@" >>"$junit_xml_path"
1060 }
1061
1062 xml_attr_encode () {
1063         printf '%s\n' "$@" | test-tool xml-encode
1064 }
1065
1066 write_junit_xml_testcase () {
1067         junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1068         shift
1069         junit_attrs="$junit_attrs classname=\"$this_test\""
1070         junit_attrs="$junit_attrs time=\"$(test-tool \
1071                 date getnanos $junit_start)\""
1072         write_junit_xml "$(printf '%s\n' \
1073                 "    <testcase $junit_attrs>" "$@" "    </testcase>")"
1074         junit_have_testcase=t
1075 }
1076
1077 finalize_junit_xml () {
1078         if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1079         then
1080                 test -n "$junit_have_testcase" || {
1081                         junit_start=$(test-tool date getnanos)
1082                         write_junit_xml_testcase "all tests skipped"
1083                 }
1084
1085                 # adjust the overall time
1086                 junit_time=$(test-tool date getnanos $junit_suite_start)
1087                 sed -e "s/\(<testsuite.*\) time=\"[^\"]*\"/\1/" \
1088                         -e "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1089                         -e '/^ *<\/testsuite/d' \
1090                         <"$junit_xml_path" >"$junit_xml_path.new"
1091                 mv "$junit_xml_path.new" "$junit_xml_path"
1092
1093                 write_junit_xml "  </testsuite>" "</testsuites>"
1094                 write_junit_xml=
1095         fi
1096 }
1097
1098 test_atexit_cleanup=:
1099 test_atexit_handler () {
1100         # In a succeeding test script 'test_atexit_handler' is invoked
1101         # twice: first from 'test_done', then from 'die' in the trap on
1102         # EXIT.
1103         # This condition and resetting 'test_atexit_cleanup' below makes
1104         # sure that the registered cleanup commands are run only once.
1105         test : != "$test_atexit_cleanup" || return 0
1106
1107         setup_malloc_check
1108         test_eval_ "$test_atexit_cleanup"
1109         test_atexit_cleanup=:
1110         teardown_malloc_check
1111 }
1112
1113 test_done () {
1114         GIT_EXIT_OK=t
1115
1116         # Run the atexit commands _before_ the trash directory is
1117         # removed, so the commands can access pidfiles and socket files.
1118         test_atexit_handler
1119
1120         finalize_junit_xml
1121
1122         if test -z "$HARNESS_ACTIVE"
1123         then
1124                 mkdir -p "$TEST_RESULTS_DIR"
1125
1126                 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1127                 total $test_count
1128                 success $test_success
1129                 fixed $test_fixed
1130                 broken $test_broken
1131                 failed $test_failure
1132
1133                 EOF
1134         fi
1135
1136         if test "$test_fixed" != 0
1137         then
1138                 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1139         fi
1140         if test "$test_broken" != 0
1141         then
1142                 say_color warn "# still have $test_broken known breakage(s)"
1143         fi
1144         if test "$test_broken" != 0 || test "$test_fixed" != 0
1145         then
1146                 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1147                 msg="remaining $test_remaining test(s)"
1148         else
1149                 test_remaining=$test_count
1150                 msg="$test_count test(s)"
1151         fi
1152         case "$test_failure" in
1153         0)
1154                 if test $test_external_has_tap -eq 0
1155                 then
1156                         if test $test_remaining -gt 0
1157                         then
1158                                 say_color pass "# passed all $msg"
1159                         fi
1160
1161                         # Maybe print SKIP message
1162                         test -z "$skip_all" || skip_all="# SKIP $skip_all"
1163                         case "$test_count" in
1164                         0)
1165                                 say "1..$test_count${skip_all:+ $skip_all}"
1166                                 ;;
1167                         *)
1168                                 test -z "$skip_all" ||
1169                                 say_color warn "$skip_all"
1170                                 say "1..$test_count"
1171                                 ;;
1172                         esac
1173                 fi
1174
1175                 if test -z "$debug"
1176                 then
1177                         test -d "$TRASH_DIRECTORY" ||
1178                         error "Tests passed but trash directory already removed before test cleanup; aborting"
1179
1180                         cd "$TRASH_DIRECTORY/.." &&
1181                         rm -fr "$TRASH_DIRECTORY" || {
1182                                 # try again in a bit
1183                                 sleep 5;
1184                                 rm -fr "$TRASH_DIRECTORY"
1185                         } ||
1186                         error "Tests passed but test cleanup failed; aborting"
1187                 fi
1188                 test_at_end_hook_
1189
1190                 exit 0 ;;
1191
1192         *)
1193                 if test $test_external_has_tap -eq 0
1194                 then
1195                         say_color error "# failed $test_failure among $msg"
1196                         say "1..$test_count"
1197                 fi
1198
1199                 exit 1 ;;
1200
1201         esac
1202 }
1203
1204 if test -n "$valgrind"
1205 then
1206         make_symlink () {
1207                 test -h "$2" &&
1208                 test "$1" = "$(readlink "$2")" || {
1209                         # be super paranoid
1210                         if mkdir "$2".lock
1211                         then
1212                                 rm -f "$2" &&
1213                                 ln -s "$1" "$2" &&
1214                                 rm -r "$2".lock
1215                         else
1216                                 while test -d "$2".lock
1217                                 do
1218                                         say "Waiting for lock on $2."
1219                                         sleep 1
1220                                 done
1221                         fi
1222                 }
1223         }
1224
1225         make_valgrind_symlink () {
1226                 # handle only executables, unless they are shell libraries that
1227                 # need to be in the exec-path.
1228                 test -x "$1" ||
1229                 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1230                 return;
1231
1232                 base=$(basename "$1")
1233                 case "$base" in
1234                 test-*)
1235                         symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1236                         ;;
1237                 *)
1238                         symlink_target="$GIT_BUILD_DIR/$base"
1239                         ;;
1240                 esac
1241                 # do not override scripts
1242                 if test -x "$symlink_target" &&
1243                     test ! -d "$symlink_target" &&
1244                     test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1245                 then
1246                         symlink_target=../valgrind.sh
1247                 fi
1248                 case "$base" in
1249                 *.sh|*.perl)
1250                         symlink_target=../unprocessed-script
1251                 esac
1252                 # create the link, or replace it if it is out of date
1253                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1254         }
1255
1256         # override all git executables in TEST_DIRECTORY/..
1257         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1258         mkdir -p "$GIT_VALGRIND"/bin
1259         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1260         do
1261                 make_valgrind_symlink $file
1262         done
1263         # special-case the mergetools loadables
1264         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1265         OLDIFS=$IFS
1266         IFS=:
1267         for path in $PATH
1268         do
1269                 ls "$path"/git-* 2> /dev/null |
1270                 while read file
1271                 do
1272                         make_valgrind_symlink "$file"
1273                 done
1274         done
1275         IFS=$OLDIFS
1276         PATH=$GIT_VALGRIND/bin:$PATH
1277         GIT_EXEC_PATH=$GIT_VALGRIND/bin
1278         export GIT_VALGRIND
1279         GIT_VALGRIND_MODE="$valgrind"
1280         export GIT_VALGRIND_MODE
1281         GIT_VALGRIND_ENABLED=t
1282         test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1283         export GIT_VALGRIND_ENABLED
1284 elif test -n "$GIT_TEST_INSTALLED"
1285 then
1286         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
1287         error "Cannot run git from $GIT_TEST_INSTALLED."
1288         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1289         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1290 else # normal case, use ../bin-wrappers only unless $with_dashes:
1291         if test -n "$no_bin_wrappers"
1292         then
1293                 with_dashes=t
1294         else
1295                 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1296                 if ! test -x "$git_bin_dir/git"
1297                 then
1298                         if test -z "$with_dashes"
1299                         then
1300                                 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1301                         fi
1302                         with_dashes=t
1303                 fi
1304                 PATH="$git_bin_dir:$PATH"
1305         fi
1306         GIT_EXEC_PATH=$GIT_BUILD_DIR
1307         if test -n "$with_dashes"
1308         then
1309                 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1310         fi
1311 fi
1312 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1313 GIT_CONFIG_NOSYSTEM=1
1314 GIT_ATTR_NOSYSTEM=1
1315 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1316
1317 if test -z "$GIT_TEST_CMP"
1318 then
1319         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1320         then
1321                 GIT_TEST_CMP="$DIFF -c"
1322         else
1323                 GIT_TEST_CMP="$DIFF -u"
1324         fi
1325 fi
1326
1327 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1328 export GITPERLLIB
1329 test -d "$GIT_BUILD_DIR"/templates/blt || {
1330         error "You haven't built things yet, have you?"
1331 }
1332
1333 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1334 then
1335         echo >&2 'You need to build test-tool:'
1336         echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1337         exit 1
1338 fi
1339
1340 # Test repository
1341 rm -fr "$TRASH_DIRECTORY" || {
1342         GIT_EXIT_OK=t
1343         echo >&5 "FATAL: Cannot prepare test area"
1344         exit 1
1345 }
1346
1347 HOME="$TRASH_DIRECTORY"
1348 GNUPGHOME="$HOME/gnupg-home-not-used"
1349 export HOME GNUPGHOME
1350
1351 if test -z "$TEST_NO_CREATE_REPO"
1352 then
1353         test_create_repo "$TRASH_DIRECTORY"
1354 else
1355         mkdir -p "$TRASH_DIRECTORY"
1356 fi
1357
1358 # Use -P to resolve symlinks in our working directory so that the cwd
1359 # in subprocesses like git equals our $PWD (for pathname comparisons).
1360 cd -P "$TRASH_DIRECTORY" || exit 1
1361
1362 this_test=${0##*/}
1363 this_test=${this_test%%-*}
1364 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1365 then
1366         say_color info >&3 "skipping test $this_test altogether"
1367         skip_all="skip all tests in $this_test"
1368         test_done
1369 fi
1370
1371 if test -n "$write_junit_xml"
1372 then
1373         junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1374         mkdir -p "$junit_xml_dir"
1375         junit_xml_base=${0##*/}
1376         junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1377         junit_attrs="name=\"${junit_xml_base%.sh}\""
1378         junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1379                 date +%Y-%m-%dT%H:%M:%S)\""
1380         write_junit_xml --truncate "<testsuites>" "  <testsuite $junit_attrs>"
1381         junit_suite_start=$(test-tool date getnanos)
1382         if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1383         then
1384                 GIT_TEST_TEE_OFFSET=0
1385         fi
1386 fi
1387
1388 # Convenience
1389 # A regexp to match 5, 35 and 40 hexdigits
1390 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1391 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1392 _x40="$_x35$_x05"
1393
1394 test_oid_init
1395
1396 ZERO_OID=$(test_oid zero)
1397 OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1398 OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1399 EMPTY_TREE=$(test_oid empty_tree)
1400 EMPTY_BLOB=$(test_oid empty_blob)
1401 _z40=$ZERO_OID
1402
1403 # Provide an implementation of the 'yes' utility; the upper bound
1404 # limit is there to help Windows that cannot stop this loop from
1405 # wasting cycles when the downstream stops reading, so do not be
1406 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1407 # limit the output of the yes utility", 2016-02-02)
1408 yes () {
1409         if test $# = 0
1410         then
1411                 y=y
1412         else
1413                 y="$*"
1414         fi
1415
1416         i=0
1417         while test $i -lt 99
1418         do
1419                 echo "$y"
1420                 i=$(($i+1))
1421         done
1422 }
1423
1424 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1425 # thus needs to be set up really early, and set an internal variable
1426 # for convenience so the hot test_set_prereq() codepath doesn't need
1427 # to call "git env--helper" (via test_bool_env). Only do that work
1428 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1429 GIT_TEST_FAIL_PREREQS_INTERNAL=
1430 if test -n "$GIT_TEST_FAIL_PREREQS"
1431 then
1432         if test_bool_env GIT_TEST_FAIL_PREREQS false
1433         then
1434                 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1435                 test_set_prereq FAIL_PREREQS
1436         fi
1437 else
1438         test_lazy_prereq FAIL_PREREQS '
1439                 test_bool_env GIT_TEST_FAIL_PREREQS false
1440         '
1441 fi
1442
1443 # Fix some commands on Windows, and other OS-specific things
1444 uname_s=$(uname -s)
1445 case $uname_s in
1446 *MINGW*)
1447         # Windows has its own (incompatible) sort and find
1448         sort () {
1449                 /usr/bin/sort "$@"
1450         }
1451         find () {
1452                 /usr/bin/find "$@"
1453         }
1454         # git sees Windows-style pwd
1455         pwd () {
1456                 builtin pwd -W
1457         }
1458         # no POSIX permissions
1459         # backslashes in pathspec are converted to '/'
1460         # exec does not inherit the PID
1461         test_set_prereq MINGW
1462         test_set_prereq NATIVE_CRLF
1463         test_set_prereq SED_STRIPS_CR
1464         test_set_prereq GREP_STRIPS_CR
1465         test_set_prereq WINDOWS
1466         GIT_TEST_CMP=mingw_test_cmp
1467         ;;
1468 *CYGWIN*)
1469         test_set_prereq POSIXPERM
1470         test_set_prereq EXECKEEPSPID
1471         test_set_prereq CYGWIN
1472         test_set_prereq SED_STRIPS_CR
1473         test_set_prereq GREP_STRIPS_CR
1474         test_set_prereq WINDOWS
1475         ;;
1476 *)
1477         test_set_prereq POSIXPERM
1478         test_set_prereq BSLASHPSPEC
1479         test_set_prereq EXECKEEPSPID
1480         ;;
1481 esac
1482
1483 # Detect arches where a few things don't work
1484 uname_m=$(uname -m)
1485 case $uname_m in
1486 parisc* | hppa*)
1487         test_set_prereq HPPA
1488         ;;
1489 esac
1490
1491 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1492 test -z "$NO_PERL" && test_set_prereq PERL
1493 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1494 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1495 test -n "$USE_LIBPCRE2" && test_set_prereq PCRE
1496 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1497 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1498
1499 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1500 then
1501         GIT_TEST_CHECK_CACHE_TREE=true
1502         export GIT_TEST_CHECK_CACHE_TREE
1503 fi
1504
1505 test_lazy_prereq PIPE '
1506         # test whether the filesystem supports FIFOs
1507         test_have_prereq !MINGW,!CYGWIN &&
1508         rm -f testfifo && mkfifo testfifo
1509 '
1510
1511 test_lazy_prereq SYMLINKS '
1512         # test whether the filesystem supports symbolic links
1513         ln -s x y && test -h y
1514 '
1515
1516 test_lazy_prereq FILEMODE '
1517         test "$(git config --bool core.filemode)" = true
1518 '
1519
1520 test_lazy_prereq CASE_INSENSITIVE_FS '
1521         echo good >CamelCase &&
1522         echo bad >camelcase &&
1523         test "$(cat CamelCase)" != good
1524 '
1525
1526 test_lazy_prereq FUNNYNAMES '
1527         test_have_prereq !MINGW &&
1528         touch -- \
1529                 "FUNNYNAMES tab embedded" \
1530                 "FUNNYNAMES \"quote embedded\"" \
1531                 "FUNNYNAMES newline
1532 embedded" 2>/dev/null &&
1533         rm -- \
1534                 "FUNNYNAMES tab embedded" \
1535                 "FUNNYNAMES \"quote embedded\"" \
1536                 "FUNNYNAMES newline
1537 embedded" 2>/dev/null
1538 '
1539
1540 test_lazy_prereq UTF8_NFD_TO_NFC '
1541         # check whether FS converts nfd unicode to nfc
1542         auml=$(printf "\303\244")
1543         aumlcdiar=$(printf "\141\314\210")
1544         >"$auml" &&
1545         test -f "$aumlcdiar"
1546 '
1547
1548 test_lazy_prereq AUTOIDENT '
1549         sane_unset GIT_AUTHOR_NAME &&
1550         sane_unset GIT_AUTHOR_EMAIL &&
1551         git var GIT_AUTHOR_IDENT
1552 '
1553
1554 test_lazy_prereq EXPENSIVE '
1555         test -n "$GIT_TEST_LONG"
1556 '
1557
1558 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1559         test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1560 '
1561
1562 test_lazy_prereq USR_BIN_TIME '
1563         test -x /usr/bin/time
1564 '
1565
1566 test_lazy_prereq NOT_ROOT '
1567         uid=$(id -u) &&
1568         test "$uid" != 0
1569 '
1570
1571 test_lazy_prereq JGIT '
1572         jgit --version
1573 '
1574
1575 # SANITY is about "can you correctly predict what the filesystem would
1576 # do by only looking at the permission bits of the files and
1577 # directories?"  A typical example of !SANITY is running the test
1578 # suite as root, where a test may expect "chmod -r file && cat file"
1579 # to fail because file is supposed to be unreadable after a successful
1580 # chmod.  In an environment (i.e. combination of what filesystem is
1581 # being used and who is running the tests) that lacks SANITY, you may
1582 # be able to delete or create a file when the containing directory
1583 # doesn't have write permissions, or access a file even if the
1584 # containing directory doesn't have read or execute permissions.
1585
1586 test_lazy_prereq SANITY '
1587         mkdir SANETESTD.1 SANETESTD.2 &&
1588
1589         chmod +w SANETESTD.1 SANETESTD.2 &&
1590         >SANETESTD.1/x 2>SANETESTD.2/x &&
1591         chmod -w SANETESTD.1 &&
1592         chmod -r SANETESTD.1/x &&
1593         chmod -rx SANETESTD.2 ||
1594         BUG "cannot prepare SANETESTD"
1595
1596         ! test -r SANETESTD.1/x &&
1597         ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1598         status=$?
1599
1600         chmod +rwx SANETESTD.1 SANETESTD.2 &&
1601         rm -rf SANETESTD.1 SANETESTD.2 ||
1602         BUG "cannot clean SANETESTD"
1603         return $status
1604 '
1605
1606 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1607 GIT_UNZIP=${GIT_UNZIP:-unzip}
1608 test_lazy_prereq UNZIP '
1609         "$GIT_UNZIP" -v
1610         test $? -ne 127
1611 '
1612
1613 run_with_limited_cmdline () {
1614         (ulimit -s 128 && "$@")
1615 }
1616
1617 test_lazy_prereq CMDLINE_LIMIT '
1618         test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1619         run_with_limited_cmdline true
1620 '
1621
1622 run_with_limited_stack () {
1623         (ulimit -s 128 && "$@")
1624 }
1625
1626 test_lazy_prereq ULIMIT_STACK_SIZE '
1627         test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1628         run_with_limited_stack true
1629 '
1630
1631 run_with_limited_open_files () {
1632         (ulimit -n 32 && "$@")
1633 }
1634
1635 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1636         test_have_prereq !MINGW,!CYGWIN &&
1637         run_with_limited_open_files true
1638 '
1639
1640 build_option () {
1641         git version --build-options |
1642         sed -ne "s/^$1: //p"
1643 }
1644
1645 test_lazy_prereq LONG_IS_64BIT '
1646         test 8 -le "$(build_option sizeof-long)"
1647 '
1648
1649 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1650 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1651
1652 test_lazy_prereq CURL '
1653         curl --version
1654 '
1655
1656 # SHA1 is a test if the hash algorithm in use is SHA-1.  This is both for tests
1657 # which will not work with other hash algorithms and tests that work but don't
1658 # test anything meaningful (e.g. special values which cause short collisions).
1659 test_lazy_prereq SHA1 '
1660         case "$GIT_DEFAULT_HASH" in
1661         sha1) true ;;
1662         "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1663         *) false ;;
1664         esac
1665 '
1666
1667 test_lazy_prereq REBASE_P '
1668         test -z "$GIT_TEST_SKIP_REBASE_P"
1669 '
1670
1671 # Ensure that no test accidentally triggers a Git command
1672 # that runs the actual maintenance scheduler, affecting a user's
1673 # system permanently.
1674 # Tests that verify the scheduler integration must set this locally
1675 # to avoid errors.
1676 GIT_TEST_MAINT_SCHEDULER="none:exit 1"